-- InviteMe, by Cidrei (Jazrei of Zangarmarsh-US)

-- Locals
local version = "30000.1"
local chatprefix = "!inviteme"
local InviteMe = {}

function InviteMe.OnEvent()
	if event == "ADDON_LOADED" and arg1 == "InviteMe" then
		SLASH_InviteMe1 = "/inviteme"
		SlashCmdList["InviteMe"] = InviteMe.ChatCommandHandler
		InviteMe.SavedVars()
	elseif InviteMeSV["On"] and event == "CHAT_MSG_WHISPER" then
		InviteMe.Invitez0rz(arg1, arg2)
	end
end

function InviteMe.SavedVars()
	if InviteMeSV == nil then
		InviteMeSV = {}
		InviteMeSV["On"] = 1
	end
end

function InviteMe.Invitez0rz(prefix, name)
	if prefix == chatprefix then
		if IsPartyLeader() == 1 or GetNumPartyMembers() == 0 then
			InviteUnit(name)
		else
			SendChatMessage("InviteMe: "..UnitName("player").." is not the party leader.", "WHISPER", nil, name)
		end
	else
		return
	end
end

-- Command parsing by tigerheart. Rest in peace, man.
function InviteMe.GetCommand(msg)
 	if msg then
 		local a,b,c = strfind(msg, "(%S+)")
 		if a then
 			return c, strsub(msg, b+2)
 		else	
 			return ""
 		end
 	end
 end

function InviteMe.ChatCommandHandler(msg)
	local cmd, subcmd = InviteMe.GetCommand(msg)
	if cmd == "toggle" then
		if not InviteMeSV["On"] then
			InviteMeSV["On"] = 1
			InviteMe.Print("InviteMe: |cffff2020Enabled")
		else
			InviteMeSV["On"] = nil
			InviteMe.Print("InviteMe: |cffff2020Disabled")
		end
	else
		local status = ""
		if InviteMeSV["On"] then
			status = "|cffff2020Enabled|cff20ff20"
		else
			status = "|cffff2020Disabled|cff20ff20"
		end
		InviteMe.Print("InviteMe v"..version..": "..status.."\n/InviteMe toggle - Toggles InviteMe on or off. Default is off.")
	end
end

function InviteMe.Print(msg) 
	if not DEFAULT_CHAT_FRAME then
		return
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20"..msg)
end

-- Need a frame to attach to.
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("CHAT_MSG_WHISPER")
f:SetScript("OnEvent", InviteMe.OnEvent)
